<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xmlns:ui="http://java.sun.com/jsf/facelets" xmlns:h="http://java.sun.com/jsf/html" xmlns:f="http://java.sun.com/jsf/core"
  xmlns:ship="http://xmlns.jcp.org/jsf/composite/ship" xmlns:p="http://primefaces.org/ui">
<h:head></h:head>
<h:body>
  <ui:composition template="/pages/pridiatemplate.xhtml">
    <ui:define name="location">
      <ship:buttongroup rendered="#{studyModel.element != null}">
        <ui:repeat value="#{studyModel.parents}" var="b" varStatus="status">
          <p:commandButton id="btn_breadcrumb" action="#{studyController.toWelcome(b.id)}" value="#{b.name}" styleClass="breadcrumbbutton" disabled="#{b.disableBreadcrumb}"
            ajax="false" />
        </ui:repeat>
      </ship:buttongroup>
    </ui:define>
    <ui:define name="body">
      <ui:fragment rendered="#{studyModel.element != null}">
        <style type="text/css">
.stayOnTopDistance {
	height: 72px !important;
}
</style>
      </ui:fragment>
      <p:dataView id="structure_welcome" value="#{studyModel.elements}" var="s" layout="grid" gridIcon="pi pi-th-large" listIcon="pi pi-bars" rendered="#{studyModel.element == null}">
        <f:facet name="header">
          <h:outputText value="#{facesContext.translate('title.study.welcome')}" />
        </f:facet>
        <p:dataViewGridItem>
          <p:panel header="#{s.name}">
            <h:panelGrid columns="2">
              <h:outputText value="#{facesContext.translate('label.name')}" />
              <h:outputText id="studyname" value="#{s.name}" style="font-weight: bolder" />
              <h:outputText value="#{facesContext.translate('label.study.parent')}" />
              <h:outputText value="#{s.studygroup}" styleClass="squarebadge" />
              <h:outputText value="#{facesContext.translate('label.varlabel')}" />
              <ship:outputTranslation value="#{s.translation}" showIsoBadge="false" />
            </h:panelGrid>
            <p:commandButton id="btn_study" action="#{studyController.toWelcome(s.id)}" value="#{facesContext.translate('button.use')}" ajax="false" />
            <p:commandButton id="btn_meta" action="#{studyController.toDeptmeta(s)}" value="#{facesContext.translate('label.instructions.study.metavariable.edit')}" ajax="false"
              rendered="#{s.accessLevel.write and not s.isVariable}" />
            <p:commandButton id="btn_vars" action="#{studyController.toStudyvars(s.id, s.name)}" value="#{facesContext.translate('label.instructions.study.studyvars.edit')}" ajax="false"
              rendered="#{s.accessLevel.write and not s.isVariable}" />
          </p:panel>
        </p:dataViewGridItem>
        <p:dataViewListItem>
          <h:panelGrid columns="4" columnClasses="width100px, width100px, width200px" width="100%">
            <h:outputText value="#{s.name}" style="font-weight: bolder" />
            <h:outputText value="#{s.studygroup}" styleClass="squarebadge" />
            <ship:outputTranslation value="#{s.translation}" showIsoBadge="false" />
            <ship:buttongroup>
              <p:commandButton id="btn_study" action="#{studyController.toWelcome(s.id)}" value="#{facesContext.translate('button.use')}" ajax="false" />
              <p:commandButton id="btn_meta" action="#{studyController.toDeptmeta(s)}" value="#{facesContext.translate('label.instructions.study.metavariable.edit')}" ajax="false"
                rendered="#{s.accessLevel.write and not s.isVariable}" />
              <p:commandButton id="btn_vars" action="#{studyController.toStudyvars(s.id, s.name)}" value="#{facesContext.translate('label.instructions.study.studyvars.edit')}" ajax="false"
              	rendered="#{s.accessLevel.write and not s.isVariable}" />
            </ship:buttongroup>
          </h:panelGrid>
        </p:dataViewListItem>
      </p:dataView>
      <p:panel header="#{facesContext.translate('panel.study.element', studyModel.element.name)}" rendered="#{studyModel.element != null}">

        <!-- TODO: add a search box here for semantic searches within all children (also use umls codes) -->

        <p:dataTable id="studystructure" value="#{studyModel.elements}" var="s">
          <p:column headerText="#{facesContext.translate('label.name')}" filterable="true" filterMatchMode="contains" filterBy="#{s.name}" sortBy="#{s.name}" sortable="true"
            styleClass="column-name">
            <ui:fragment rendered="#{s.accessLevel.read}">
              <p:commandLink id='link_toDept' action="#{studyController.toWelcome(s.id)}" value="➜ #{s.name}" ajax="false" rendered="#{not s.isVariable}" />
              <h:outputText value="#{s.name}" rendered="#{s.isVariable}" />
            </ui:fragment>
          </p:column>
          <p:column headerText="#{facesContext.translate('label.varlabel')}" styleClass="column-description">
            <ship:outputTranslation value="#{s.translation}" showIsoBadge="false" rendered="#{s.accessLevel.read}" />
          </p:column>
          <p:column headerText="#{facesContext.translate('label.actions')}" styleClass="fouriconbuttons">
            <ship:buttongroup>
              <p:commandButton id="btn_show" action="#{studyController.toShow(s)}" value="" title="#{facesContext.translate('button.show')}" icon="fa fa-info-circle" ajax="false"
                immediate="true" rendered="#{s.accessLevel.read}" styleClass="iconbutton" />
              <p:menuButton id="btn_editgrp" value="" icon="fa fa-pencil" style="height: 36px" rendered="#{s.accessLevel.write}" styleClass="iconbutton">
                <p:menuitem id="btn_edit" action="#{studyController.toEdit(s)}" value="#{facesContext.translate(s.isVariable ? 'button.edit.variable' : 'button.edit.element')}" ajax="false" immediate="true" />
                <p:menuitem id="btn_meta" action="#{studyController.toMetadata(s)}" value="#{facesContext.translate('label.instructions.study.metavariable.edit')}" ajax="false"
                  immediate="true" rendered="#{s.isVariable}" />
                <p:menuitem id="btn_dept" action="#{studyController.toDeptmeta(s)}" value="#{facesContext.translate('label.instructions.study.metavariable.edit')}" ajax="false"
                  immediate="true" rendered="#{not s.isVariable}" />
              </p:menuButton>
              <p:commandButton id="btn_user2" action="#{studyController.toUser(s)}" value="" title="#{facesContext.translate('button.user')}" icon="fa fa-group" ajax="false" immediate="true"
                rendered="#{s.accessLevel.write}" styleClass="iconbutton" />
              <ship:removeButton id="btn_delete" action="#{studyController.doDeleteElementOrVariable(s)}" title="#{facesContext.translate('title.delete.approve')}"
                tooltip="#{facesContext.translate('button.remove')}" approveButtonLabel="#{facesContext.translate('button.yes')}" cancelButtonLabel="#{facesContext.translate('button.no')}"
                rendered="#{s.accessLevel.write}">
                <h:outputText value="#{facesContext.translate('confirmation.delete', s.name)}" />
                <br />
                <h:outputText value="#{facesContext.translate('information.study.delete.hierarchy.subelements')}" styleClass="dangerText" />
              </ship:removeButton>
            </ship:buttongroup>
          </p:column>
        </p:dataTable>
      </p:panel>

      <p:dialog widgetVar="dialog_varattr" header="#{facesContext.translate('label.panel.study.meta.variableattributes')}" modal="true" closable="true" closeOnEscape="true" backdrop="false"
        rendered="#{studyModel.element != null}">
        <p:staticMessage severity="info" detail="#{facesContext.translate('info.study.meta.variableattributes')}" />
        <p:accordionPanel rendered="#{studyController.mightUseStudy()}">
          <p:tab id="download_attr" title="#{facesContext.translate('button.download')}" titleStyleClass="accordionpanelheader">
            <p:inputSwitch id="switch" value="#{studyModel.includeSections}" label="#{facesContext.translate('label.study.download.includesection')}" />
            <p:commandButton id="btn_download1" action="#{studyController.doDownloadVariableAttributes(studyModel.element.id)}" icon="download" ajax="false"
              value="#{facesContext.translate('button.download.metadata.ods')}" />
          </p:tab>
          <!-- deactivated until squaremetadatainterface works for uploading variableattributes from the xlsx format
					<b:panel id="upload_attr" title="#{facesContext.translate('button.upload')}">
	    	    <b:alert severity="warning" closable="true">
  	    	    <h:outputText value="#{facesContext.translate('warn.study.uploadmeta')}" />
    	    	</b:alert>
						<b:panelGrid colSpans="3,9" size="sm">
							<h:outputText value="#{facesContext.translate('label.study.metaupload.file')}" />
							<h:inputFile id="file" value="#{studyModel.uploadBean.file}" />
							<h:outputText value="#{facesContext.translate('label.study.smi.type')}" />
							<b:selectOneMenu id="type" value="#{studyModel.uploadBean.type}">
								<f:selectItems value="#{studyModel.smitypes}" var="t" itemValue="#{t}" itemLabel="#{t}" />
							</b:selectOneMenu>
						</b:panelGrid>
	          <b:commandButton id="btn_upload1" action="#{studyController.doFileUploadVariableAttributes}" iconAwesome="upload" value="#{facesContext.translate('title.study.uploadmeta')}" />
					</b:panel>
					-->
        </p:accordionPanel>
        <h:outputText value="#{facesContext.translate('error.variableattributes.nostudyusagepriv', studyModel.element.name)}" rendered="#{!studyController.mightUseStudy()}" />
      </p:dialog>

      <p:dialog widgetVar="dialog_procvars" header="#{facesContext.translate('label.panel.study.meta.metadatavariables')}" modal="true" closable="true" closeOnEscape="true" backdrop="false"
        rendered="#{studyModel.element != null}">
        <f:facet name="anchor">
          <i class="fa fa-tasks"></i>
        </f:facet>
        <p:staticMessage severity="info" detail="#{facesContext.translate('info.study.meta.metadatavariables')}" />
        <p:accordionPanel rendered="#{studyController.mightUseStudy()}">
          <p:tab id="download_process" title="#{facesContext.translate('button.download')}" titleStyleClass="accordionpanelheader">
            <p:commandButton id="btn_download2" action="#{studyController.doDownloadConfounder(studyModel.element.id)}" icon="download" ajax="false"
              value="#{facesContext.translate('button.download.metaref')}" />
          </p:tab>
          <p:tab id="upload_process" title="#{facesContext.translate('button.upload')}" titleStyleClass="accordionpanelheader">
            <p:panelGrid columns="2">
              <h:outputText value="#{facesContext.translate('label.study.metaupload.file')}" title="#{facesContext.translate('tooltip.study.filename')}" />
              <h:inputFile id="metareffile" value="#{studyModel.uploadMetaref.file}" />
              <h:outputText value="#{facesContext.translate('label.study.smi.type')}" />
              <p:selectOneMenu id="metareftype" value="#{studyModel.uploadMetaref.type}">
                <f:selectItems value="#{studyModel.smitypes}" var="t" itemValue="#{t}" itemLabel="#{t}" />
              </p:selectOneMenu>
            </p:panelGrid>
            <p:commandButton id="btn_upload2" action="#{studyController.doUploadMetaref}" ajax="false" icon="upload" value="#{facesContext.translate('button.upload.metaref')}" />
          </p:tab>
        </p:accordionPanel>
        <h:outputText value="#{facesContext.translate('error.variableattributes.nostudyusagepriv', studyModel.element.name)}" rendered="#{!studyController.mightUseStudy()}" />
      </p:dialog>

      <p:dialog widgetVar="dialog_io" header="#{facesContext.translate('label.panel.study.io')}" modal="true" width="640" closable="true" closeOnEscape="true" backdrop="false"
        rendered="#{studyModel.element != null}">
        <p:accordionPanel id="acc" rendered="#{studyController.mightUseStudy()}">
          <h:outputText value="TODO: remove #{studyModel.hasNoSections}" />
          <p:tab id="import_opal" title="#{facesContext.translate('title.import.opal')}" titleStyleClass="accordionpanelheader">
            <p:staticMessage severity="info" summary="#{facesContext.translate('label.hint')}" detail="#{facesContext.translate('hint.study.import.opal')}" />
            <p:messages />
            <p:panelGrid columns="2">
              <h:outputText value="#{facesContext.translate('label.study.io.opal.select')}" />
              <p:selectOneMenu id="import_opal_url" value="#{studyModel.opalBean.url}" rendered="#{studyModel.opalBean.hasUrls}" onchange="ship.processing(10000)">
                <p:ajax event="change" update="form:acc:import_opal_project" listener="#{studyController.doResetOpalProjects}" oncomplete="ship.processed()" />
                <f:selectItem itemValue="" itemLabel="#{facesContext.translate('button.choose')}" />
                <f:selectItems value="#{studyModel.opalBean.urls}" var="o" itemValue="#{o}" itemLabel="#{o}" />
              </p:selectOneMenu>
              <h:outputText value="#{facesContext.translate('instruction.study.io.opal.nourls')}" rendered="#{!studyModel.opalBean.hasUrls}" />
              <h:outputText value="#{facesContext.translate('label.study.io.opal.project')}" />
              <p:selectOneMenu id="import_opal_project" value="#{studyModel.opalBean.project}" onchange="ship.processing(10000)">
                <p:ajax event="change" update="form:acc:import_opal_table" listener="#{studyController.doResetOpalTables}" oncomplete="ship.processed()" />
                <f:selectItem itemValue="" itemLabel="#{facesContext.translate('button.choose')}" />
                <f:selectItems value="#{studyModel.opalBean.projects}" var="o" itemValue="#{o}" itemLabel="#{o}" />
              </p:selectOneMenu>
              <h:outputText value="#{facesContext.translate('label.study.io.opal.table')}" />
              <p:selectOneMenu id="import_opal_table" value="#{studyModel.opalBean.table}">
                <f:selectItem itemValue="" itemLabel="#{facesContext.translate('button.choose')}" />
                <f:selectItems value="#{studyModel.opalBean.tables}" var="o" itemValue="#{o}" itemLabel="#{o}" />
              </p:selectOneMenu>
              <h:outputText value="#{facesContext.translate('label.study.io.opal.parent')}" />
              <p:selectOneMenu id="import_opal_into" value="#{studyModel.opalBean.parentUniqueName}">
                <f:selectItem itemValue="" itemLabel="#{facesContext.translate('button.choose')}" />
                <f:selectItems value="#{studyModel.elementsThatAreSections}" var="o" itemValue="#{o.uniqueName}" itemLabel="#{o.name}" />
              </p:selectOneMenu>
            </p:panelGrid>
            <p:commandButton id="btn_import_opal" action="#{studyController.doImportOpal}" onclick="ship.processing(10000)" ajax="false" value="#{facesContext.translate('button.import.opal')}" />
          </p:tab>
          <p:tab id="import_ship" title="#{facesContext.translate('title.import.ship')}" titleStyleClass="accordionpanelheader">
            <p:staticMessage severity="info" summary="#{facesContext.translate('label.hint')}" detail="#{facesContext.translate('hint.study.import.ship')}" />
            <p:messages />
            <p:panelGrid columns="2">
              <h:outputText value="#{facesContext.translate('label.study.io.ship.select')}" />
              <p:inputText value="#{studyModel.shipBean.srcUniqueName}" />
              <h:outputText value="#{facesContext.translate('label.study.io.ship.locale')}" />
              <p:selectOneMenu id="import_ship_locale" value="#{studyModel.shipBean.locale}">
                <f:selectItems value="#{lang.countries}" var="l" itemValue="#{l}" itemLabel="#{l.getDisplayName(l)}" />
              </p:selectOneMenu>
              <h:outputText value="#{facesContext.translate('label.study.io.opal.parent')}" />
              <p:selectOneMenu id="import_ship_into" value="#{studyModel.shipBean.destUniqueName}">
                <f:selectItem itemValue="" itemLabel="#{facesContext.translate('button.choose')}" />
                <f:selectItems value="#{studyModel.elementsThatAreSections}" var="o" itemValue="#{o.uniqueName}" itemLabel="#{o.name}" />
              </p:selectOneMenu>
            </p:panelGrid>
            <p:commandButton id="btn_import_ship" action="#{studyController.doImportShip}" onclick="ship.processing(10000)" ajax="false" value="#{facesContext.translate('button.import.ship')}" />
          </p:tab>
        </p:accordionPanel>
        <h:outputText value="#{facesContext.translate('error.variableattributes.nostudyusagepriv', studyModel.element.name)}" rendered="#{!studyController.mightUseStudy()}" />
      </p:dialog>
    </ui:define>
    <ui:define name="formbuttons">
      <p:commandButton id="btn_back" action="#{studyController.toWelcome}" value="#{facesContext.translate('button.overview')}" immediate="true" rendered="#{studyModel.element != null}"
        ajax="false" />
      <p:commandButton id="btn_adddept" action="#{studyController.toAddDepartment}" value="#{facesContext.translate('label.instructions.study.department.add')}" ajax="false"
        rendered="#{studyModel.element != null}" disabled="#{!studyModel.element.accessLevel.write}" />
      <p:commandButton id="btn_addvar" action="#{studyController.toAddVariable}" value="#{facesContext.translate('label.instructions.study.variable.add')}" ajax="false"
        rendered="#{studyModel.element != null}" disabled="#{!studyModel.element.accessLevel.write}" />
      <p:commandButton id="btn_va" value="#{facesContext.translate('label.panel.study.meta.variableattributes')}" onclick="PF('dialog_varattr').show();"
        rendered="#{studyModel.element != null and studyModel.element.accessLevel.write}" />
      <p:commandButton id="btn_imp" value="#{facesContext.translate('button.import')}" onclick="PF('dialog_io').show();" disabled="#{studyModel.hasNoSections}"
        title="#{facesContext.translateif(studyModel.hasNoSections, 'info.study.io.opal.missingsection')}" style="pointer-events: all"
        rendered="#{studyModel.element != null and studyModel.element.accessLevel.write}" />
      <p:commandButton id="btn_missinglist" action="#{studyController.toMissinglist}" value="#{facesContext.translate('button.edit.missinglist')}" ajax="false" />
    </ui:define>
    <ui:define name="help_de">
      <ui:fragment rendered="#{studyModel.element == null}">
    Sie befinden sich jetzt innerhalb der ausgewählten Studie. Am Hierarchiebaum können Sie erkennen, in welchem Bereich Sie sich aufhalten. <br />
        <br />

        <b>Fußzeile:</b> Über <i>Element hinzufügen</i> können neue Bereiche bzw. neue Variablen erstellt werden. Außerdem können Sie Prozessvariablen und Missings bearbeiten. Unter <i>Import/Export</i> können Sie Variablenattribute hoch- bzw. runterladen. Das Herunterladen der Variablenattribute generiert eine Datei im ODS-Format, das Hochladen kann wahlweise aus einer ODS- oder einer Excel-Datei erfolgen. <br />
        <br />

        <b>Tabelle:</b>  Wenn Sie spezifische Bereiche/Variablen bzw. die zugehörigen Prozessvariablen bearbeiten wollen, können Sie dies über das Stiftsymbol tun. Möchten Sie die Informationen über den Bereich oder die Variable - einschließlich der Variablenattribute - nur einsehen, klicken Sie auf den Info-Button. Auch die Rechte für einzelne Elemente können über das entsprechende Symbol individuell bearbeitet werden.
  </ui:fragment>
      <ui:fragment rendered="#{studyModel.element != null}">
   	In dem Modul <b>Studienstruktur</b> werden alle Elemente einer Studie strukturiert angelegt. Dies umfasst alle Untersuchungen und die darin erfassten Studienvariablen, gegebenenfalls gegliedert in mehrere Hierarchieebenen.<br />
        <br />

Neben hierarchisch angeordneten Strukturelementen und Variablen sind auch Metadaten anzulegen. Diese umfassen erstens Attribute zu einzelnen Variablen, z.B. Plausibilitätsgrenzen oder Missings. Weiterhin sind Prozessvariablen zuzuordnen. Diese liegen wie andere Studienvariablen im Datensatz vor, beziehen sich jedoch auf andere Variablen und spezifizieren deren Messprozess, z.B. durch Angabe des Untersuchers, des Geräts oder der Startzeit.<br />
        <br />

Idealerweise sind diese Metadaten bereits in einem verfügbaren Data Dictionary angelegt und dadurch importierbar. Ist dies nicht der Fall, können alle erforderlichen Strukturen auch händisch angelegt werden.<br />
        <br />

Wählen Sie dazu eine bestimmte, bereits unter dem Punkt <b>Studienübersicht</b> angelegte Studie in der Tabelle aus. Innerhalb der Studie stehen Ihnen dann alle Funktionen zur Verfügung.<br />
        <br />

Missingcodes können in Missinglisten global von jeder Ebene aus bearbeitet werden. Klicken Sie dazu auf <i>Missings bearbeiten</i>.
  </ui:fragment>
    </ui:define>
    <ui:define name="help_en">
      <ui:fragment rendered="#{studyModel.element == null}">
    You are in a selected study. The hierarchy tree shows you which section you have entered. <br />
        <br />

        <b>Footer:</b> Via <i>add element</i> you can create new sections or variables. You can also edit process variable assignments and missing lists specifying missing code. By clicking <i>import/export</i> you can up- or download variable attributes. Downloading the variable attributes generates an ODS-file, an upload can be done from either an ODS or an Excel-file. <br />
        <br />

        <b>Table:</b> If you want to edit certain sections/variables or the corresponding process variables, you can do this via the pencil button. If you just want to see information about a section or a variable - including the variable attributes -, please click the info-button. Besides the permissions for certain elements can be edited individually via the button with the respective icon.
  </ui:fragment>
      <ui:fragment rendered="#{studyModel.element != null}">
     In the module <b>study structure</b> all elements of a study are created in a structured way. This includes all examinations/study sections and the recorded study variables, arranged on several hierarchical levels, if necessary.<br />
        <br />

Beside these structure elements and the variables, metadata should be created. Metadata includes attributes for single variables, e.g. plausibility limits or missing codes, as well as process variable assignments. These are, like the study variables, part of the data, but refer to other sections/variables and specify their meassurement process, e.g. by recording the exeminer ids, device ids, or examination times.<br />
        <br />

Usually, these elements have been previously generated in a data dictionary and can be easily imported. If not, all necessary structures can be created manually.<br />
        <br />

To do so, select a specific study from the table, which has already been created in the module <b>study overview</b>. Within the study, all necessary functionallity for such metadata annotations are available.<br />
        <br />

Missing codes, organized in missinglists, can be edited globally from every hierarchical level by clicking <i>edit missings</i>.
  </ui:fragment>
    </ui:define>
  </ui:composition>
</h:body>
</html>
